var extractFbPath = require('../extract-fb-path');
var moment = require('moment');

module.exports = {
  name: 'change-input-common',
  event: 'change',
  selector: [
    'input:not([type])[data-path]',
    'input[type=text][data-path]',
    'input[type=email][data-path]',
    'input[type=date][data-path]',
    'input[type=number][data-path]',
    'textarea[data-path]'
  ].join(','),
  handler: function(e) {
    var fbPath = extractFbPath(e.target);
    var fbRoot = this.lookupFbRoot(fbPath);
    var valueRef = fbRoot.dataRef.child(fbPath.path);

    var value = e.target.value;

    if (value === '') {
      valueRef.remove();
    } else if (e.target.getAttribute('data-format') === 'date') {
      var m = moment(value);

      if (m.isValid()) {
        valueRef.set(m.format('YYYY-MM-DD'));
        e.target.value = m.format('MMMM D, YYYY');
      }
    } else {
      valueRef.set(value);
    }
  }
};
