/* globals FileReader */

var extractFbPath = require('../extract-fb-path');
var resize = require('../resize');

module.exports = {
  name: 'change-input-file',
  event: 'change',
  selector: 'input[type=file][data-path]',
  handler: function(e) {
    var fbPath = extractFbPath(e.target);
    var fbRoot = this.lookupFbRoot(fbPath);
    var file = e.target.files[0];
    var reader = new FileReader();
    reader.onload = function(e) {
      var fileMeta = {
        lastModified: file.lastModified,
        name: file.name,
        size: file.size,
        type: file.type
      };
      if (file.type.match(/^image\//)) {
        var thumb = resize(e.target.result, 100);
        fbRoot.uploadsRef.child(fbPath.path + '/thumb').set(thumb, function() {
          fbRoot.dataRef.child(fbPath.path).set(fileMeta, function() {
            fbRoot.uploadsRef.child(fbPath.path + '/raw').set(e.target.result);
          });
        });
      } else {
        fbRoot.uploadsRef.child(fbPath.path).set(e.target.result, function() {
          fbRoot.dataRef.child(fbPath.path).set(fileMeta);
        });
      }
    };

    reader.readAsDataURL(file);
  }
};
