var moment = require('moment');

module.exports = {
  name: 'input',
  selector: 'input[data-path],textarea[data-path]',
  update: function (el, newValue) {
    switch (el.type) {
      case 'file':
        break;
      case 'checkbox':
        el.checked = newValue === 1;
        break;
      default:
        if (el.getAttribute('format') === 'date') {
          el.value = moment(newValue, 'YYYY-MM-DD').format('MMMM D, YYYY');
        } else {
          el.value = newValue || '';
        }
    }
  }
};